<?php

	session_start();
	$customDebug = "false";

    function startsWith($haystack, $needle)
    {
        return $needle === "" || strpos($haystack, $needle) === 0;
    }
    function endsWith($haystack, $needle)
    {
        return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
    }

    // error_log("xxcustom:");
    /* foreach($_GET as $key => $value)
    {
       error_log($key);
       error_log($value);
    } */

    // extract LMS URL 
    if(isset($_GET['lmsUrl'])){
        $reqURL = substr($_SERVER['QUERY_STRING'],7);
        $reqURL = str_replace('&amp;','&',$reqURL);
    }

    if ($customDebug === "true") {
		error_log("xxcustom: LMS Url set to:" . $reqURL);
	}		
	
    // read post input body
    $handle = fopen('php://input', "r");
    $msg="";

    if ($handle) {
        while (($reqLine = fgets($handle)) != null) {
           $msg = $msg . $reqLine . " \n ";
        }
    } 
    else {
        // error opening the file.
        if ($customDebug === "true") {
			error_log("xxcustom: Error reading input");
		}
        /* foreach($_GET as $key => $value)
        {
           error_log($key);
           error_log($value);
        }  */   
    } 
    $msg = trim($msg);
	$encrMsg = $msg;
	$nstr = "";

	for ($x=0; $x < strlen($msg); $x+=3) {
		
		$nstr = $nstr . chr(base_convert(substr($msg, $x, 3),36,10));
		// echo chr(base_convert(substr($msg, $x, 3),36,10))."<br>";			
		// echo $nstr."<br>";
	}
	// echo $nstr."<br>";		
    $msg = $nstr;
	
    if ($customDebug === "true") {
		error_log("xxcustom: Message:" . $encrMsg);
		error_log("xxcustom: Decoded Message:" . $msg);
	}
	 
    if(strpos($msg,'oracle.apps.ota.private.isValidURI')>0){
        $isValid = true;
        //$msgArray1 = explode("&",$msg);
		//Modified due to Oracle 12.2 patch change
		$msgArray1 = explode("~olmota~",$msg);
        $arrCount = count($msgArray1);
        $ind = 0;
        while($ind < $arrCount){
            $partMsg1 = $msgArray1[$ind];
            if(startsWith($partMsg1,"oracle.apps.ota.private.isValidURI")){
                $identifier = substr($partMsg1,strpos($partMsg1,"=") + 1);
                if ($identifier != null) {
                    try{
                        $headers = get_headers($identifier, 1);
                        if ($headers[0] == 'HTTP/1.1 200 OK') {
                            $isValid = true;
                        }
                        else
                        {
                            throw new Exception('URL not valid.');
                            $isValid = false;
                        }
                    }
                    catch(Exception $e){
						if ($customDebug === "true") {                        
							error_log("xxcustom:".$e);
						}
                        echo "Error: $e";
                    }
                }
                if($isValid) {
                    $isValidText = "true";
                }    
                else {
                    $isValidText = "false";
                }
                $returnMsg = "oracle.apps.ota.private.isValidURI=".$isValidText;
                $returnMsg = $returnMsg."\n"."error_text="."\n"."error=0";
                file_put_contents("php://output",$returnMsg);
                break;
            }
            $ind++;
        }
    }
    else
    {
        $gotResponse = null;
		$sesCk = null;
		$msgArray2 = explode("~olmota~",$msg);
		$arrCount2 = count($msgArray2);
		$sesId = null;
		$discardSess = false;
        $ind = 0;
		if ($customDebug === "true") {
				error_log("arrCount2:" . $arrCount2);
				error_log("ind:" . $ind);
		}
        while($ind < $arrCount2){
            $partMsg2 = $msgArray2[$ind];
			$part1 = substr($partMsg2,0,strpos($partMsg2,"="));
			$part2 = substr($partMsg2,strpos($partMsg2,"=")+1); 
			 if($part1 == "oracle.apps.ota.private.sessionId")
			 {
				$sesId = $part2;
			 }
			 else if("action"==$part1 && "ExitAU"==$part2)
			 {
				$discardSess = true;
			 }
			 $ind++;
		}
		
		if ($customDebug === "true") {
			error_log("xxcustom url:" . $reqURL);
			error_log("xxcustom data:" . $encrMsg);
			error_log("part2:" . $part2);	
            error_log("sesId:" . $sesId);			
        }
		
        // initialize curl once, try 20 times
        $curl = curl_init();
		$contextAttr = $sesId."HDR";
        //$headers = array();
        //$headers[] = 'Content-Type: application/x-www-form-urlencoded';
		try{
			if(isset($_SESSION[$contextAttr])){
				$sesCk = $_SESSION[$contextAttr];
			}
			if ($customDebug === "true") {
				error_log("SESSION[$contextAttr] retrieved as :".$sesCk);
			}	
		}
		catch(Exception $e){
			error_log("Inside exception for SESSION[$contextAttr]:");
		}
        //$headers = array('Content-Type: application/x-www-form-urlencoded','User-Agent: Mozilla/5.0');
		$headers = array('Content-Type: application/x-www-form-urlencoded','User-Agent: Mozilla/5.0','Cookie: '.$sesCk);
        curl_setopt($curl , CURLOPT_URL, $reqURL);
        //curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        //curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($curl, CURLOPT_CAINFO, getcwd() . "/CAcerts/cacert.pem");
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, "scormd=".$encrMsg); 
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER,$headers);        
        //
		curl_setopt($curl, CURLOPT_HEADER, 1);
        try{
            $response =	curl_exec($curl);
            $gotResponse = true;
			// Return headers seperatly from the Response Body
            $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
            $resp_headers = substr($response, 0, $header_size);
			$resp_headers_arr = explode("\r\n", $resp_headers);
			$lms_cookie = null;
            foreach ($resp_headers_arr as &$r_header) {
			  if( strpos( $r_header, 'Set-Cookie' ) !== false) {
				  $cookie_value = explode(":", $r_header);
				  $lms_cookie = $lms_cookie.$cookie_value[1].';';
			  }// end-if
            }// end-foreach-loop
			if ($customDebug === "true") {
				error_log("Cookie for LMS: ". $lms_cookie);
		    }
			if($lms_cookie != null){
				if( strpos($reqURL, 'esr.nhs.uk' ) !== false){
					$lms_cookie = str_replace("internal.uk.com","esr.nhs.uk",$lms_cookie);
				}				
				$_SESSION[$contextAttr] = $lms_cookie;
			}
			if ($customDebug === "true") {
				error_log("SESSION[$contextAttr] set to : ". $_SESSION[$contextAttr]);
			}
        }// end-try
        catch(Exception $e){
			if ($customDebug === "true") {
				error_log("xxcustom: Error occurred when trying to get inputstream for reading response in round trip:".$e);
				error_log("xxcustom: Error - ".curl_error($curl)." - Code: ".curl_errno($curl));
			}
            die('Error: "' . curl_error($curl) . '" - Code: ' . curl_errno($curl));			
            echo "Error occurred when trying to get inputstream for reading response in round trip";
        }
			

        
        if(!$response){
       		if ($customDebug === "true") {
				error_log("xxcustom: Error - ".curl_error($curl)." - Code: ".curl_errno($curl));
			}
            die('Error: "' . curl_error($curl) . '" - Code: ' . curl_errno($curl));
        }
        
        // close cURL resource, and free up system resources
        curl_close($curl);
        echo $response;
		if($discardSess)
        {
			session_unset();
			session_destroy();
			if ($customDebug === "true") {
				error_log("SESSION[$contextAttr] unset and destroyed : ");
			}
        }
    }

    fclose($handle);
?>